#!/usr/bin/gawk -f

BEGIN{
  pi = 3.1415926535;
  km = 1.e3;
  G = 6.67e-11;		# SI
  rho_PB = 2500.;	# kg/m^3

  D_complete = ARGV[1];
  D_minimal = ARGV[2];
  ARGV[1] = ARGV[2] = "";
}
(ARGIND==3){
  a = $2;  # (D^a)
  b = $1;  # (10^b)
}
(ARGIND>1){
  D = $1;
  if (D >= D_complete) {
    V = (pi/6.) * D**3;
    V1 += V;
  }
}
(ARGIND>1) && (FNR==1){
  D_LR = $1;
}
(ARGIND>1) && (FNR==2){
  D_LF = $1;
}
END{
  D1 = ((6./pi) * V1)**(1./3.);
  V_LR = (pi/6.) * D_LR**3;
  V_LF = (pi/6.) * D_LF**3;

  print "D_complete = " D_complete " km";
  print "V1 = " V1 " km^3";
  print "D1 = " D1 " km";
  print "";

  V0 = V1 - pi/6. * 1. * 10.**b * a/(a+3) * (D_complete**(a+3) - D_minimal**(a+3));
  D0 = ((6./pi) * V0)**(1./3.);
  LR_PB = V_LR/V0;
  LF_PB = V_LF/V0;
  R_PB = D0*1.e3/2.;
  v_esc = sqrt(8./3.*pi*G*rho_PB) * R_PB;

  print "D_minimal = " D_minimal " km";
  print "a = " a " (D^a)"
  print "b = " b " (10^b)"
  print "V0 = " V0 " km^3";
  print "D0 = " D0 " km";
  print "LR/PB = " LR_PB "";
  print "LF/PB = " LF_PB "";
  print "rho_PB = ", rho_PB, " kg m^-3"
  print "v_esc = " v_esc " m/s = ", v_esc/km, " km/s";

  TMP="D_complete.plt"
  print "a=" a >TMP;
  print "b=" b >TMP;
  print "D_complete=" D_complete >TMP;
  print "D_minimal=" D_minimal >TMP;
  print "V1=" V1 >TMP;
}

