#!/usr/bin/gnuplot

# parent_body_volume_D_complete.plt
# Miroslav Broz (miroslav.broz@email.cz), Apr 1st 2008

set colors classic
set term x11

load "D_complete.plt"

V_gt_D(D) = V1 - pi/6. * 1. * 10.**b * a/(a+3) * (D_complete**(a+3) - D**(a+3))
D_PB(D) = (6./pi * V_gt_D(D))**(1./3.)

########################################################################

set xl "{/Helvetica-Oblique D} / km"
set yl "{/Helvetica-Oblique D}_{PB} / km" offset 1

set xr [D_minimal:D_complete]
set autoscale y
set samples 1000
set nokey

set label "{/Helvetica-Oblique D}_{complete}" at D_complete, D_PB(D_complete)
set label "  {/Helvetica-Oblique D}_{PB}" at D_minimal, D_PB(D_minimal)

p D_PB(x) w l lw 5,\
  "<echo \"1 1\"" u ($1*D_minimal):($2*D_PB(D_minimal)) w p lt 1 ps 2 pt 7

pa -1

set term post eps enh solid color "Helvetica" 18
set size 0.7,0.9
set out "parent_body_size.eps"
rep


